// Copyright © 2017 Project Golan, all rights reserved.
#include "r_draw.h"

#include "g_stage.h"
#include "m_str.h"

#include <Doominati.h>

// Static Functions ----------------------------------------------------------|

//
// R_drawHitboxes
//
static void R_drawHitboxes(void)
{
   DGE_Texture_Bind(0);
   DGE_Draw_SetColor(1lr, 0, 0, 0.5lr);

   unsigned head = DGE_Thinker_Head();
   DGE_Point2 vp = DGE_Renderer_GetViewpoint();

   for(DGE_Thinker th = {head}; (th.id = th.next) != head;) {
      DGE_PhysicsThinker pth;
      if((pth.id = DGE_Object_Cast(th.id, DGE_OT_PhysicsThinker))) {
         fixed tx = pth.x - vp.x, ty = pth.y - vp.y;
         DGE_Draw_Rectangle(tx - pth.sx, ty - pth.sy, tx + pth.sx, ty + pth.sy);
      }
   }

   DGE_Draw_SetColor();
}

// Extern Functions ----------------------------------------------------------|

//
// R_Draw
//
DGE_Callback
void R_Draw(ulfra delta)
{
   DGE_Shader_Bind(DGE_Shader_Get(s"plasma"));
   DGE_Texture_Bind(0);
   DGE_Draw_Rectangle(0, 0, 960, 720);
   DGE_Shader_Bind(0);
}

//
// R_DrawPost
//
DGE_Callback
void R_DrawPost(ulfra delta)
{
   DGE_Texture_Bind(DGE_Texture_Get(s"gui/border"));
   DGE_Draw_Rectangle(0, 0, 960, 720);

   DGE_Font_Bind(DGE_Font_Get(s"base"));
   DGE_Draw_SetTextAlign(DGE_Align_Center);
   DGE_Draw_Text(760, 20, G_place);
   DGE_Draw_SetTextAlign(DGE_Align_Left);
   DGE_Draw_Text(585, 70, u8"ハイスコア\nスコア\n\n残り再試行回");
   DGE_Draw_SetTextAlign(DGE_Align_Right);
   DGE_Draw_Text(945, 70, M_StrFmt("%.15i\n%.15i\n\n%i", 0, 0, 5));

   R_drawHitboxes();
}

// EOF
